#!/usr/X11R6/bin/wish8.0
######### OBS!!! My wish is linked to wish4.2 #########################
## This file will probably generate errors if executed using wish4.2 ##
## You should change the above path, if wish8.0 is located elsewhere ##
## in your system.                                                   ##
#######################################################################             
#
#Athanasios Migdalas (migdalas@dias.ergasya.tuc.gr)
#
#A try to a tcl GUI interface for FreeAmp, in order
#to make it run easily for multiple mp3 files.
#
#######################################################################
##       CHANGE THIS TO THE freeamp PATH in YOYR SYSTEM              ##
#######################################################################
set FREEAMPPATH /usr/local/bin
#######################################################################
##   CHANGE THIS TO THE DIRECTORY OF INSTALLATION OF MSCC            ##
#######################################################################
set MSCCINSTALLDIR /home/sakis/Sakis/Programs/Tcl-Tk/FreeAmp
#
############ NO NEED TO TOUCH BELOW THIS LINE #########################


proc ErrorBox {} {
    global tit
    set eb [tk_messageBox -title $tit \
            -message "Error: No mp3 files in the specified directory!" \
		-icon error -type ok]
}

proc OpenError {} {
    global tit
    set eb [tk_messageBox -title $tit \
            -message "Error: File doesn't seem to be a Play List.\
                     Can't be opened!" \
		-icon error -type ok]
}

proc ShutHelp {} {
     global vh
     wm withdraw $vh
}

proc Find {argWhat} {
     global ht
    set start [$ht search -count cnt -exact -- $argWhat 1.0 end ]
    $ht tag add sel "$start linestart" "$start +$cnt chars"
    $ht see $start
    
}

proc HelpMessage {} {
    global vh bm MSCCINSTALLDIR tit gif1 gif3 ht
    if [winfo exists .h] {
       wm deiconify .h
       focus .h
    } else {
       set vh [toplevel .h ]
       wm title .h $tit
       wm iconbitmap $vh @$bm
        set vh2 [frame .h.h1 -background blue -relief solid]
        pack $vh2 -side top -fill x
	set im1 [image create photo -file $gif1]
        set im2 [image create photo -file $gif3]
	set him1 [label $vh2.l -image $im1]
        set him2 [label $vh2.l2 -image $im2]
        set him3 [label $vh2.l3 -text "  run_freeamp *  v 0.001 *  MP3 Play List Selector for FreeAmp" \
		      -background blue -foreground yellow]
	set vh3 [frame .h.h2]
        pack $vh3 -side top -fill x
        set vh4 [frame .h.h3]
        pack $vh4 -side top -fill x
       set hp [button $vh4.can -text Cancel -width 12 -command ShutHelp]
	set what [button $vh3.wh -text "What ?" -width 12 -command {Find "GOOD NEWS:"}]
        set install [button $vh3.ins -text "Install ?" -width 12 -command {Find "INSTALL:"}]
        set use [button $vh3.us -text "Use ?" -width 12 -command {Find "USE:"}]
        set buts [button $vh3.bts -text "Menu ?" -width 12 -command {Find "Buttons:"}]
        set playM [button $vh3.plm -text "Play ?" -width 12 -command {Find "Music:"}]
        set playL [button $vh3.lst -text "Lists ?" -width 12 -command {Find "Lists:"}]
       set toDo [button $vh4.tdo -text "To Do ?" -width 12 -command {Find "DO:"}]
        set warr [button $vh4.war -text "Warranty ?" -width 12 -command {Find "WARRANTY:"}]
        set copy [button $vh4.cop -text "Copying ?" -width 12 -command {Find "COPYING:"}]
        set probl [button $vh4.prob -text "Problem ?" -width 12 -command {Find "REPORTING:"}]
        set why [button $vh4.why -text "Why ?" -width 12 -command {Find "HISTORY:"}]
       set ht [ScrollableText .h.hp -width 60 -height 10 -relief sunken]
       pack $vh2.l $vh2.l2 $vh2.l3 -padx 0 -side left
       pack $what $install $use $buts $playM $playL -side left
       pack  $toDo $warr $copy $probl $why $hp -side left
       pack .h.hp -side bottom -fill both -expand true
       focus $vh
        set hlpFile "README"
	set hlpFile [file join $MSCCINSTALLDIR $hlpFile]
	if [catch {open $hlpFile} in] {
           OpenError
	} else {
          $ht configure -state normal
	  $ht insert end [read $in]
          $ht configure -state disabled
          close $in
	}
    }
}

proc ShutNoFile {} {
     global nnh
     wm withdraw $nnh
}

proc PutNoFiles {} {
    global nnh bm noFile th nr tit
    if [winfo exists .nh] {
       $th configure -state normal
       $th delete 1.0 end
       $th insert end "These $nr items in the Play List are not files!\n\n"
       $th insert end $noFile
       $th configure -state disabled
       wm deiconify .nh
       focus .nh
    } else {
	set nnh [toplevel .nh]
        wm title .nh $tit
        wm iconbitmap $nnh @$bm
        set nhp [button .nh.ch -text Cancel -command ShutNoFile]
        set th [ScrollableText .nh.nhp -width 60 -height 10 -relief sunken]
        pack .nh.ch -side top -fill x
        pack .nh.nhp -side bottom -fill both -expand true
        focus $nnh
        $th insert end "These $nr items in the Play List are not files!\n\n"
        $th insert end $noFile
        $th configure -state disabled
    }
}

## Procedure from "Practical Programming in Tcl and Tk" ##
## By Brent B. Welch                                    ##
## A book that I wormly recommend                       ##
proc ScrollableText { fr args} {
    frame $fr
    eval {text $fr.txt \
	      -xscrollcommand [list $fr.xscroll set] \
              -yscrollcommand [list $fr.yscroll set]} $args
          scrollbar $fr.yscroll -orient vertical \
        	 -command [list $fr.txt yview]
          scrollbar $fr.xscroll -orient horizontal \
        	 -command [list $fr.txt xview]
          grid $fr.txt $fr.yscroll -sticky news
          grid $fr.xscroll -sticky news
          grid rowconfigure $fr 0 -weight 1
          grid columnconfigure $fr 0 -weight 1
          return $fr.txt
}  
###########################################################

proc MakeCmd {} {
     global FREEAMPPATH mp3files cmd
     set cmd exec
     append cmd " " [file join $FREEAMPPATH freeamp]
     append cmd " " $mp3files " " "&"
}

proc PlayFreeAmp {} {
     global bf bp en id t br be cmd
     MakeCmd
     set id [eval $cmd ]
     $t configure -state normal
     $bp configure -state disabled
     $en configure -state disabled
     $br configure -state normal
     $be configure -state normal
}

proc ResetFreeAmp {} {
     global id t bf bp en br m me
     if { $id != -100} {
          catch [ exec kill $id ] ier
     }
     $t configure -state normal
     $t delete 1.0 end
     $bf configure -state normal
     $bp configure -state disabled
     set id -100  ;# Will be set to the pid of FreeAmp
     $en configure -state normal
     $m entryconfigure 4 -state disabled
     $m entryconfigure 5 -state disabled
     $me entryconfigure 1 -state disabled
     $me entryconfigure 2 -state disabled
     $me entryconfigure 3 -state disabled     
     focus $en
     $en delete 0 end
     $br configure -state disabled
}

proc NewPlayList {} {
     global t en bp m lb me
       #Menu items are accessed using numbers from 0
       $m entryconfigure 4 -state normal
       $m entryconfigure 5 -state normal
       $me entryconfigure 1 -state normal
       $me entryconfigure 2 -state normal
       $me entryconfigure 3 -state normal
       $me entryconfigure 6 -state normal
       #Reconfigure the label widget
       $lb config -text "Default Play List:"
       #Reconfigure the entry widget. Make it read-only
       $en configure -state normal
       $en delete 0 end
       $en insert 0 "Group-list.txt"
       $en configure -state disabled
       $t configure -state normal
       $t delete 1.0 end
       focus $t
}

proc OpenPlayList {} {
    global of t m lb en me bp id
    set typelist { 
                  {"Text Files" {".txt"}} 
                  {"All Files" {*}}
    }
    set of [tk_getOpenFile -title "Select Play List" -initialdir ~/. -defaultextension txt \
                           -filetypes $typelist]
    if {$of != ""} {
       #Menu items are accessed using numbers from 0
       $m entryconfigure 4 -state normal
       $m entryconfigure 5 -state normal
       $me entryconfigure 1 -state normal
       $me entryconfigure 2 -state normal
       $me entryconfigure 3 -state normal
       $me entryconfigure 6 -state normal
       #Reconfigure the label widget
       $lb config -text "Play List:"
       #Reconfigure the entry widget. Make it read-only
       $en configure -state normal
       $en delete 0 end
       $en insert 0 $of
       $en configure -state disabled
       if [catch {open $of} in] {
          OpenError
       } else {
	   if [file readable $of] {
              $t configure -state normal
              $t delete 1.0 end
              $t insert end [read $in]
              close $in
              if {$id == -100} {
                MakeList
                $bp configure -state normal
              }
	   } else {
              OpenError
           }
       }
    }
}

proc MakeList {} {
    global of mp3files noFile nr
    set mp3files ""
    set noFile ""  
    set nr 0
    if [catch {open $of r} fid] {
       OpenError
    } else {
	while {[gets $fid line] >= 0} {
            if {[file exists $line]} {
                append mp3files [ glob -nocomplain $line] " "
            } else {
                append noFile $line "\n"
                incr nr
            }
	}
        close $fid
    }
    if {$nr != 0} {
          PutNoFiles
    }
}

proc SavePlayList {} {
    global of t bp id
    if {$of !=""} {
       if [catch {open $of w} fin] {
          OpenError
       } else {
           $t configure -state normal
	   set wtxt [$t get 1.0 end]
           puts $fin $wtxt
           close $fin
       }
    }
    if {$id == -100} {
         MakeList
         $bp configure -state normal
    }
}

proc SaveAs {} {
     global t m lb en of me be id bp
     set inf "Group-list.txt"
     set typelist { 
                  {"Text Files" {".txt"}} 
                  {"All Files" {*}}
     }
     set of [tk_getSaveFile -title "Name Play List" -initialdir ~/. -defaultextension txt \
                           -filetypes $typelist -initialfile $inf]
      if {$of != ""} {
       $m entryconfigure 4 -state normal
       $m entryconfigure 5 -state normal
       $be configure -state normal
       $me entryconfigure 1 -state normal
       $me entryconfigure 2 -state normal
       $me entryconfigure 3 -state normal
       $me entryconfigure 6 -state normal
       #Reconfigure the label widget
       $lb config -text "Play List:"
       #Reconfigure the entry widget. Make it read-only
       $en configure -state normal
       $en delete 0 end
       $en insert 0 $of
       $en configure -state disabled
       if [catch {open $of w} fin] {
          OpenError
       } else {
           $t configure -state normal
	   set wtxt [$t get 1.0 end]
           puts $fin $wtxt
           close $fin
       }
      }
    if {$id == -100} {
         MakeList
         $bp configure -state normal
    }
}

proc AddFile {} {
    global t
    set f ""
    set typelist {
	{"MP3 Files" {".mp3"}}
        {"All Files" {*}}
    }
    set f [tk_getOpenFile -title "Select File to Add" -initialdir ~/. -defaultextension mp3 \
               -filetypes $typelist]
    if {$f != ""} {
       append f "\n"
       $t insert end $f 
       $t see end
    }
}

proc DeleteFile {} {
     global t cut me
     set cut [$t get "insert linestart" "insert lineend + 1 char"]
     $t delete "insert linestart" "insert lineend +1 char"
     $me entryconfigure 4 -state normal
}

proc PasteFile {} {
     global t cut 
     $t insert "insert linestart" $cut
}

proc CopyFile {} {
     global t cut me
     set cut [$t get "insert linestart" "insert lineend + 1 char"]
     $me entryconfigure 4 -state normal
}


proc GetAll {} {
     global mp3files bp inputDir t m mf me en be
     set mp3dir $inputDir
     if [ file isdirectory $inputDir] {
        set mp3path [file join $mp3dir *.mp3]
        if [catch { glob $mp3path } mp3files] {
          ErrorBox
        } else {
           #Unfortunately it complains if you use $mp3files. So I had to repeat the whole thing
	   foreach f [lsort -dictionary [glob -nocomplain [file join $mp3dir *.mp3]]] {
                $t insert end $f\n
                $t see end
	   }
          $bp configure -state normal
          $en configure -state disabled
          $be configure -state disabled
          $t configure -state disabled
          #Note that menu items are accessed using numbers from 0
          $m entryconfigure 5 -state normal
          $me entryconfigure 1 -state disabled
          $me entryconfigure 2 -state disabled
          $me entryconfigure 3 -state disabled
       }
     } else {
       ErrorBox
     } 
}

proc Quit {} {
    global id
    if { $id != -100} {
        catch [ exec kill $id ] ier
    }
    exit
}

proc GetDir {} {
    global inputDir bm locDir gd tit
    set locDir $inputDir
    set inputDir ""
    if [winfo exists .g] {
       wm deiconify .g
       focus .g
    } else {
       set gd [toplevel .g]
       wm title .g $tit
       wm iconbitmap $gd @$bm
       set glb [label $gd.gl -text "Directory with MP3 Files:" -padx 0]
       set gen [entry $gd.gn -width 20 -relief sunken -textvariable inputDir]
       set gbt [button $gd.gb -text OK -width 8 -command AddDir]
       set gbc [button $gd.gc -text Cancel -width 8 -command {set inputDir $locDir
        	wm withdraw .g}]
       pack $gd.gl -side left
       pack $gd.gn -side left -fill x -expand true
       pack $gd.gb $gd.gc -side left
       bind $gd.gn <Return> AddDir
       focus $gd.gn
    }
}

proc AddDir {} {
     global mp3files inputDir t gd
     wm withdraw $gd
     set mp3dir $inputDir
     if [ file isdirectory $inputDir] {
        set mp3path [file join $mp3dir *.mp3]
        if [catch { glob $mp3path } mp3files] {
          ErrorBox
        } else {
	   foreach f [lsort -dictionary [glob -nocomplain [file join $mp3dir *.mp3]]] {
                $t insert end $f\n
	   }
       }
     } else {
       ErrorBox
     } 
}

set bm1 [file join $MSCCINSTALLDIR macstar.xbm]
set bm2 [file join $MSCCINSTALLDIR mscclogo.xbm]
set bm3 [file join $MSCCINSTALLDIR mscc.xbm]
set bm $bm1
set gif1 [file join $MSCCINSTALLDIR macstar.gif]
set gif2 [file join $MSCCINSTALLDIR mscc.gif]
set gif3 [file join $MSCCINSTALLDIR mscclogo.gif]
set tit "MSCC MP3 Play List Selector for FreeAmp"

wm minsize . 60 12
wm iconbitmap . @$bm1
wm title . $tit

set b [frame .mnbar]
set bf [menubutton $b.file -relief raised -text List -menu $b.file.menu -width 9]
    set m [menu $b.file.menu -tearoff 1]
    set mn [$m add command -label "New Play List" -command NewPlayList]
    set mo [$m add command -label "Open Play List" -command OpenPlayList]
    $m add separator
    set ms [$m add command -label "Save Play List" -command SavePlayList -state disabled]
    set ma [$m add command -label "Save Play List As ..." -command SaveAs -state disabled]
set be [menubutton $b.edit -relief raised -text Edit -menu $b.edit.menu -width 9]
set me [menu $b.edit.menu -tearoff 1]
    set mf [$me add command -label "Add MP3 File to Play List" -command AddFile -state disabled]
    set md [$me add command -label "Cut MP3 Item from Play List" -command DeleteFile -state disabled]
    set mk [$me add command -label "Copy MP3 Item from Play List" -command CopyFile -state disabled]
    set mc [$me add command -label "Paste MP3 Item to Play List" -command PasteFile -state disabled]
    $me add separator
    set mr [$me add command -label "Add all MP3 Files from Dir ..." -command GetDir -state disabled]
set bp [button $b.play -text FreeAmp -command PlayFreeAmp -state disabled -width 9]
set br [button $b.reset -text Reset -command ResetFreeAmp -state disabled -width 9]
button $b.quit -text Quit -command Quit -width 9
button $b.help -text Help -command HelpMessage -width 9
pack $b -side top -fill x
pack $b.file $b.edit $b.play $b.reset -side left
pack $b.quit -side left
pack $b.help -side right

set f [frame .dirEntry]
set lb [label $f.lbl -text "Directory with MP3 Files:" -padx 0]
set en [entry $f.dir -width 20 -relief sunken -textvariable inputDir]
pack $f -side top -fill x
pack $f.lbl -side left
pack $f.dir -side left -fill x -expand true
bind $f.dir <Return> GetAll 
bind $f.dir <Control-c> exit
focus $f.dir

set t [ScrollableText .lst -width 60 -height 10 -relief sunken]
pack .lst -side top -fill both -expand true

set id -100  ;# Will be set to the pid of FreeAmp
set of  ""     ;# Will be set to a file name
set vh ""     ;# Will be set to help window













      








